const httpStatus = require('http-status');
const ApiError = require('../utils/ApiError');
const LoansConditions = require('../../LoansConditions.json');

const findCredit = async (clientFields) => {
	var creditPool = {
		credits: [],
		score: 0,
		chance: 0
	};
	clientFields["CompanyInList"] = true;
	clientFields["ClosedList"] = true;
	clientFields["Last"] = clientFields["Age"] + Math.ceil((clientFields["TimeInMonth"]) / 12);

	if (clientFields["Age"] < 23) {
		creditPool.score += 9;
	}
	else if (clientFields["Age"] < 45) {
		creditPool.score += 15;
	}
	else if (clientFields["Age"] < 64) {
		creditPool.score += 34;
	}
	else {
		creditPool.score += 10;
	}

	if (clientFields["WorkAgeSummInMonth"] < 18) {
		creditPool.score += 14;
	}
	else if (clientFields["WorkAgeSummInMonth"] < 132) {
		creditPool.score += 27;
	}
	else if (clientFields["WorkAgeSummInMonth"] < 240) {
		creditPool.score += 34
	}
	else {
		creditPool.score += 34;
	}

	if (clientFields["HasRealEstate"] == true || clientFields["HasCar"] == true) {
		creditPool.score += 47;
	}
	else {
		creditPool.score += 15;
	}

	if (clientFields["LoansCount"] < 1) {
		creditPool.score += 40;
	}
	else if (clientFields["LoansCount"] < 3) {
		creditPool.score += 34;
	}
	else if (clientFields["LoansCount"] < 5) {
		creditPool.score += 15;
	}
	else {
		creditPool.score += 3;
	}
	creditPool.chance = Math.round((creditPool.score - 41) / (155 - 41) * 100);

	for (var credit in LoansConditions) {
		var f = true;
		for (var key in LoansConditions[credit]['YES']) {
			if (typeof LoansConditions[credit]['YES'][key] == 'string') {
				if (!LoansConditions[credit]['YES'][key].includes(clientFields[key]))
					f = false;
			}
			else if (typeof LoansConditions[credit]['YES'][key] == 'number') {
				if (clientFields[key] < LoansConditions[credit]['YES'][key])
					f = false;
			}
			else {
				if (clientFields[key] != LoansConditions[credit]['YES'][key])
					f = false;
			}
		}
		for (var key in LoansConditions[credit]['NO']) {
			if (typeof LoansConditions[credit]['NO'][key] == 'string') {
				if (LoansConditions[credit]['NO'][key].includes(clientFields[key]))
					f = false;
			}
			else if (typeof LoansConditions[credit]['NO'][key] == 'number') {
				if (clientFields[key] > LoansConditions[credit]['NO'][key])
					f = false;
			}
			else {
				if (clientFields[key] == LoansConditions[credit]['NO'][key])
					f = false;
			}
		}
		if (f) {
			creditPool.credits.push({
				"Name": credit,
				"Rate": LoansConditions[credit]["Args"]["Rate"]
			});
		}
	}

	creditPool.credits = creditPool.credits.sort(function (a, b) { return a["Rate"] - b["Rate"] });
	console.log(creditPool);
	return creditPool;
};

module.exports = {
	findCredit,
};
