from TelegramBot.version import (__python_version__, __version__, __pyro_version__, __license__)
from TelegramBot.logging import LOGGER
from pyrogram.types import InlineKeyboardButton

USER_TEXT = """
🗒️ Documentation for commands available to user's 

• /start: To Get this message

• /help: Alias command for start

• /alive: Check if bot is alive or not.

• /ping: Alias command for alive.

• /paste: paste text to katb.in website.
"""

SUDO_TEXT = """
🗒️ Documentation for Sudo Users commands.

• /speedtest: Check the internet speed of bot server.

• /serverstats: Get the stats of server.

• /dbstats: Get the stats of database 

• /stats: Alias command for serverstats

• /log: To get the log file of the bot.
"""

DEV_TEXT = """
🗒️ Documentation for Developers Commands.

• /update: Update the bot to latest commit from repository. 

• /restart: Restart the bot.

• /shell: Run the terminal commands via bot.

• /py: Run the python commands via bot

• /broadcast: Broadcast the message to bot users and chats.
"""

ABOUT_CAPTION = f"""• Python version : {__python_version__}
• Bot version : {__version__}
• pyrogram  version : {__pyro_version__}
• License : {__license__}

Диман фрик и Егор тоже"""

START_ANIMATION = "https://telegra.ph/file/c0857672b427bec8542f6.mp4"

START_CAPTION = """Димас Разводов == Гандонов Данил Алексеевич"""


def test_answers(pool) -> str:
    ans=rf""""""
    for question in QUESTION_PULL:
        ans += rf"""
{question["question"]} : {pool[question["name"]]}"""
    return ans


def createInlineKeyboardMarkup(questions, previouse_question) -> list:
    Button_pull = []
    callback = {"p_q":questions["id"]}
    for question in questions["variants"]:
        callback["n_q"] = question["next"]
        callback["d"] = question["name"]
        Button_pull.append(InlineKeyboardButton(question["name"], callback_data = str(callback)+ "_BUTTON"))
    Button_pull = [Button_pull]

    if previouse_question == "START":
        callback = "START"
    elif previouse_question == "END":
        callback = "END"
    else:
        callback = {"p_q":previouse_question}
    Button_pull.append([InlineKeyboardButton("🔙 Вернуться назад", callback_data = str(callback)+"_BUTTON")])
    return Button_pull


def get_all_names() -> dict:
    names = {}
    for question in QUESTION_PULL:
        names[question["name"]] = ""
    return names

QUESTION_PULL = [
  {
   "id": 1,
   "name": "employment",
    "question" : "Какое в данный момент у вас устройство на работу?",
    "type": "selector",
    "variants": [
      {
        "name": "По найму",
        "next": 2,
      },
      {
        "name": "Самозанятый",
        "next": 2,
      },
      {
        "name": "Пенсионер",
        "next": 2,
      },
      {
        "name": "ИП",
        "next": 2,
      },
      {
        "name": "Не работаю",
        "next": 2,
      },
      {
        "name": "Другое",
        "next": 2,
      }
   ]
  },
  {
    "id": 2,
   "name": "military",
    "question": "Проходили ли вы военную службу?",
    "type": "selector",
    "variants": [
      {
        "name": "Да",
        "next": 3,
      },
      {
        "name": "Нет",
        "next": 3,
      },
    ]
  },
  {
    "id": 3,
   "name": "retired",
    "question": "Вы пенсионер?",
    "type": "selector",
    "variants": [
      {
        "name": "Да",
        "next": 4,
      },
      {
        "name": "Нет",
        "next": 4,
      },
    ]
  },
  {
    "id": 4,
   "name": "holding",
    "question": "Есть ли у вас вклад в ПСБ?",
    "type": "selector",
    "variants": [
      {
        "name": "Да",
        "next": "END",
      },
      {
        "name": "Нет",
        "next": "END",
      },
    ]
  }
]
