from pyrogram import Client, filters
from pyrogram.types import (CallbackQuery, InlineKeyboardButton,
                            InlineKeyboardMarkup, Message)

import ast
from TelegramBot import bot
from TelegramBot.logging import LOGGER
from TelegramBot.helpers.start_constants import *
from TelegramBot.config import OWNER_USERID, SUDO_USERID
from TelegramBot.database import database, MongoDb
from TelegramBot.helpers.decorators import ratelimiter

# START_BUTTON = [
#     [
#         InlineKeyboardButton("📖 Commands", callback_data="COMMAND_BUTTON"),
#         InlineKeyboardButton("👨‍💻 About me", callback_data="ABOUT_BUTTON"),
#     ],
#     [
#         InlineKeyboardButton(
#             "🔭 Original Repo",
#             url="https://github.com/sanjit-sinha/TelegramBot-Boilerplate",
#         )
#     ],
# ]

START_BUTTON = [
    [
        InlineKeyboardButton("📖 Пройти Опрос", callback_data="TEST_BUTTON"),
        InlineKeyboardButton("👨‍💻 Кто я?", callback_data="ABOUT_BUTTON"),
    ],
]

TEST_EMPLOYMENT = [
    [        
        InlineKeyboardButton("По найму", callback_data="EMPLOYMENT_CASE1_BUTTON"),
        InlineKeyboardButton("Самозанятый", callback_data="EMPLOYMENT_CASE2_BUTTON"),
        InlineKeyboardButton("Пенсионер", callback_data="EMPLOYMENT_CASE3_BUTTON"),
        InlineKeyboardButton("ИП", callback_data="EMPLOYMENT_CASE4_BUTTON"),
        InlineKeyboardButton("Не работаю", callback_data="EMPLOYMENT_CASE5_BUTTON"),
        InlineKeyboardButton("Другое", callback_data="EMPLOYMENT_CASE6_BUTTON"),
    ],
]


TEST_MILITARY = [
    [        
        InlineKeyboardButton("Да", callback_data="MILITARY_CASE1_BUTTON"),
        InlineKeyboardButton("Нет", callback_data="MILITARY_CASE2_BUTTON"),
    ],
]

TEST_RETIRED = [
    [        
        InlineKeyboardButton("Да", callback_data="RETIRED_CASE1_BUTTON"),
        InlineKeyboardButton("Нет", callback_data="RETIRED_CASE2_BUTTON"),
    ],
]

TEST_HOLDING = [
    [        
        InlineKeyboardButton("Да", callback_data="HOLDING_CASE1_BUTTON"),
        InlineKeyboardButton("Нет", callback_data="HOLDING_CASE2_BUTTON"),
    ],
]

COMMAND_BUTTON = [
    [
        InlineKeyboardButton("Users", callback_data="USER_BUTTON"),
        InlineKeyboardButton("Sudo", callback_data="SUDO_BUTTON"),
    ],
    [InlineKeyboardButton("Developer", callback_data="DEV_BUTTON")],
    [InlineKeyboardButton("🔙 Go Back", callback_data="START_BUTTON")],
]


GOBACK_1_BUTTON = [[InlineKeyboardButton("🔙 Go Back", callback_data="START_BUTTON")]]
GOBACK_2_BUTTON = [[InlineKeyboardButton("🔙 Пройти тест заново", callback_data="TEST_BUTTON")]]


@Client.on_message(filters.command(["start", "help"]))
@ratelimiter
async def start(_, message: Message):
    await database.saveUser(message.from_user)
    LOGGER(__name__).info("NAMES....")
    LOGGER(__name__).info(get_all_names())
    await database.saveInfo(message.from_user.id, get_all_names())
    return await message.reply_text(
        START_CAPTION,
        reply_markup=InlineKeyboardMarkup(START_BUTTON),
        quote=True)


@Client.on_callback_query(filters.regex("_BUTTON"))
@ratelimiter
async def botCallbacks(_, CallbackQuery: CallbackQuery):

    clicker_user_id = CallbackQuery.from_user.id
    user_id = CallbackQuery.message.reply_to_message.from_user.id

    if clicker_user_id != user_id:
        return await CallbackQuery.answer("This command is not initiated by you.")

    # if CallbackQuery.data == "SUDO_BUTTON":
    #     if clicker_user_id not in SUDO_USERID:
    #         return await CallbackQuery.answer(
    #             "You are not in the sudo user list.", show_alert=True)              
    #     await CallbackQuery.edit_message_text(
    #         SUDO_TEXT, reply_markup=InlineKeyboardMarkup(GOBACK_2_BUTTON))
            
    # elif CallbackQuery.data == "DEV_BUTTON":
    #     if clicker_user_id not in OWNER_USERID:
    #         return await CallbackQuery.answer(
    #             "This is developer restricted command.", show_alert=True)                
    #     await CallbackQuery.edit_message_text(
    #         DEV_TEXT, reply_markup=InlineKeyboardMarkup(GOBACK_2_BUTTON))
            
    if CallbackQuery.data == "ABOUT_BUTTON":
        LOGGER(__name__).info("ABOUT INTRO....")
        await CallbackQuery.edit_message_text(
            ABOUT_CAPTION, reply_markup=InlineKeyboardMarkup(GOBACK_1_BUTTON))

    elif CallbackQuery.data == "START_BUTTON":
        await CallbackQuery.edit_message_text(
            START_CAPTION, reply_markup=InlineKeyboardMarkup(START_BUTTON))
       
    elif CallbackQuery.data == "TEST_BUTTON":
        LOGGER(__name__).info("TEST INTRO....")

        markup = createInlineKeyboardMarkup(QUESTION_PULL[0], "START")
        LOGGER(__name__).info(markup)
        await CallbackQuery.edit_message_text(QUESTION_PULL[0]["question"], reply_markup = InlineKeyboardMarkup(markup))
        
    elif CallbackQuery.data == "END_BUTTON":
        # await MongoDb.info.update_info_document(clicker_user_id,{'holding':"Нет"})
        await CallbackQuery.edit_message_text("ЕБал ваш рот", reply_markup=InlineKeyboardMarkup(GOBACK_2_BUTTON))
        
    else:
        info = ast.literal_eval(CallbackQuery.data[:CallbackQuery.data.rfind("_")])
        LOGGER(__name__).info(info)
        if "d" in info:
            for question in QUESTION_PULL:
                    if int(info["p_q"]) == int(question["id"]):
                        break
            await MongoDb.info.update_info_document(clicker_user_id,{question["name"]:info["d"]})

        flag = False
        # TODO :: [28-Aug-23 21:26:26 - INFO] - TelegramBot.plugins.users.start - [[pyrogram.types.InlineKeyboardButton(text='Да', callback_data="{'p_q': 2, 'n_q': 3, 'd': 'Да'}_BUTTON"), pyrogram.types.InlineKeyboardButton(text='Нет', callback_data="{'p_q': 2, 'n_q': 3, 'd': 'Нет'}_BUTTON")], [pyrogram.types.InlineKeyboardButton(text='🔙
#  Вернуться назад', callback_data="{'p_q': 1}_BUTTON")]]
# Traceback (most recent call last):
# credit-helper-app-1       |   File "/usr/local/lib/python3.9/site-packages/pyrogram/dispatcher.py", line 240, in handler_worker
# credit-helper-app-1       |     await handler.callback(self.client, *args)
# credit-helper-app-1       |   File "/app/telegram_bot/TelegramBot/helpers/decorators.py", line 45, in decorator
# credit-helper-app-1       |     else: return await func(client, update)
# credit-helper-app-1       |   File "/app/telegram_bot/TelegramBot/plugins/users/start.py", line 147, in botCallbacks
# credit-helper-app-1       |     if info["n_q"] =="END":
# credit-helper-app-1       | KeyError: 'n_q'
        if info["n_q"] =="END":
            await CallbackQuery.edit_message_text(
                test_answers(await MongoDb.info.read_document(clicker_user_id)), reply_markup=InlineKeyboardMarkup(GOBACK_2_BUTTON))
        elif "n_q" in info:
            for question in QUESTION_PULL:
                if int(info["n_q"]) == int(question["id"]):
                    flag = True
                    break
            if flag:
                if question["type"] == "selector":
                    markup = createInlineKeyboardMarkup(question, info["p_q"])
                    LOGGER(__name__).info("NEXT QUESTION....")
                    LOGGER(__name__).info(markup)
                    await CallbackQuery.edit_message_text(question["question"], reply_markup = InlineKeyboardMarkup(markup))
        else:
            for question in QUESTION_PULL:
                if int(info["p_q"]) == int(question["id"]):
                    flag = True
                    break
            if flag:
                if question["type"] == "selector":
                    markup = createInlineKeyboardMarkup(question, "START")
                    LOGGER(__name__).info("NEXT QUESTION....")
                    LOGGER(__name__).info(markup)
                    await CallbackQuery.edit_message_text(question["question"], reply_markup = InlineKeyboardMarkup(markup))
        
    # if CallbackQuery.data == "EMPLOYMENT_CASE1_BUTTON":
    #     await database.saveEmploymentInfo(clicker_user_id, "По найму")
    #     await CallbackQuery.edit_message_text(
    #         MILITARY_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_MILITARY))
        
    # elif CallbackQuery.data == "EMPLOYMENT_CASE2_BUTTON":
    #     await database.saveEmploymentInfo(clicker_user_id, "Самозанятый")
    #     await CallbackQuery.edit_message_text(
    #         MILITARY_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_MILITARY))
        
    # elif CallbackQuery.data == "EMPLOYMENT_CASE3_BUTTON":
    #     await database.saveEmploymentInfo(clicker_user_id, "Пенсионер")
    #     await CallbackQuery.edit_message_text(
    #         MILITARY_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_MILITARY))
        
    # elif CallbackQuery.data == "EMPLOYMENT_CASE4_BUTTON":
    #     await database.saveEmploymentInfo(clicker_user_id, "ИП")
    #     await CallbackQuery.edit_message_text(
    #         MILITARY_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_MILITARY))
        
    # elif CallbackQuery.data == "EMPLOYMENT_CASE5_BUTTON":
    #     await database.saveEmploymentInfo(clicker_user_id, "Не работаю")
    #     await CallbackQuery.edit_message_text(
    #         MILITARY_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_MILITARY))
        
    # elif CallbackQuery.data == "EMPLOYMENT_CASE6_BUTTON":
    #     await database.saveEmploymentInfo(clicker_user_id, "Другое")
    #     await CallbackQuery.edit_message_text(
    #         MILITARY_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_MILITARY))
        
    # if CallbackQuery.data == "MILITARY_CASE1_BUTTON":
    #     await MongoDb.info.update_info_document(clicker_user_id,{'military':"Да"})
    #     await CallbackQuery.edit_message_text(
    #         RETIRED_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_RETIRED))
        
    # elif CallbackQuery.data == "MILITARY_CASE2_BUTTON":
    #     await MongoDb.info.update_info_document(clicker_user_id,{'military':"Нет"})
    #     await CallbackQuery.edit_message_text(
    #         RETIRED_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_RETIRED))

    # if CallbackQuery.data == "RETIRED_CASE1_BUTTON":
    #     await MongoDb.info.update_info_document(clicker_user_id,{'retired':"Да"})
    #     await CallbackQuery.edit_message_text(
    #         HOLDING_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_HOLDING))
        
    # elif CallbackQuery.data == "RETIRED_CASE2_BUTTON":
    #     await MongoDb.info.update_info_document(clicker_user_id,{'retired':"Нет"})
    #     await CallbackQuery.edit_message_text(
    #         HOLDING_CAPTION, reply_markup=InlineKeyboardMarkup(TEST_HOLDING))
        
    # if CallbackQuery.data == "HOLDING_CASE1_BUTTON":
    #     await MongoDb.info.update_info_document(clicker_user_id,{'holding':"Да"})
    #     await CallbackQuery.edit_message_text(
    #         test_answers(await MongoDb.info.read_document(clicker_user_id)), reply_markup=InlineKeyboardMarkup(GOBACK_2_BUTTON))


    # elif CallbackQuery.data == "CASE2_BUTTON":
    #     LOGGER(__name__).info("Пизда....")
    #     await database.saveInfo(clicker_user_id, "ПИЗДА")
    #     text = f"Ваш ответ :{await MongoDb.info.read_document(clicker_user_id)}!"
    #     await MongoDb.info.delete_document(clicker_user_id)
    #     await CallbackQuery.edit_message_text(
    #         text, reply_markup=InlineKeyboardMarkup(GOBACK_2_BUTTON))


@Client.on_message(filters.new_chat_members, group=1)
async def newChat(_, message: Message):
    """
    Get notified when someone add bot in the group, then saves that group chat_id
    in the database.
    """

    chatid = message.chat.id
    for new_user in message.new_chat_members:
        if new_user.id == bot.me.id:
            await database.saveChat(chatid)
